//
//  ConcentrationTest.swift
//  ConcentrationTest
//
//  Created by Luciano Bononi on 07/04/18.
//  Copyright © 2018 Luciano Bononi. All rights reserved.
//

import Foundation

class ConcentrationTest {
    var cards = [Card]()
    
    var indexOfOneAndOnlyFaceUpCard: Int?
    
    func chooseCard(at index: Int) {
        if !cards[index].isMatched {
            if let matchIndex = indexOfOneAndOnlyFaceUpCard, matchIndex != index {
            //check if cards match
                if cards[matchIndex].identifier == cards[index].identifier {
                    cards[matchIndex].isMatched = true
                    cards[index].isMatched = true
                }
                cards[index].isFaceUp = true
                indexOfOneAndOnlyFaceUpCard = nil //NB set to nil since it is defined as Optional
            } else {
                // either no cards or 2 cards are face Up, first put all cards face down
                for flipDownIndex in cards.indices {
                    cards[flipDownIndex].isFaceUp = false
                }
                cards[index].isFaceUp = true
                indexOfOneAndOnlyFaceUpCard = index
            }
    }
    }
    
    init(numberOfPairsOfCards: Int) {
        for _ in 1...numberOfPairsOfCards {
        let card = Card()
        cards += [card, card]
        }
        
        // TODO: shuffle cards
        // for swapFromIndex in stride(from: 2, through: 2*(numberOfPairsOfCards - 1), by: 2) {
        //    let swapToIndex = Int(arc4random_uniform(UInt32(numberOfPairsOfCards))) * 2
        //    let temp = cards[swapFromIndex].identifier
        //    cards[swapFromIndex].identifier = cards[swapToIndex].identifier
        //    cards[swapToIndex].identifier = temp
        // }
    }
}
